'------------------------------------------------------------------------------------------------
'------------------------------------------------------------------------------------------------
'--  VISCONST.BAS - Visio global constant file. This file can be loaded into a code module.
'--  Copyright (C) 1991-1993 Shapeware Corporation. All rights reserved.
'--
'--  The constant names consist of a lowercase prefix "vis" and fully spelled words all starting
'--  with a capitalized initial (e.g., visSizeNormal). However, standard abbreviations are used
'--  for the following words;
'--
'--  Horizontal is abbreviated as Horz
'--  Vertical is abbreviated as Vert
'--  Transform is abbreviated as XForm
'--  Foreground is abbreviated as Fore
'--  Background is abbreviated as Back
'--
'--  Some constants are commented out because they have
'--  duplicates (e.g., visNone appears several places).
'--

'The application and object to create
Global Const visApi = "visio.application"

'The object ID's
Global Const visApplication = 1
Global Const visCell = 2
Global Const visDocument = 10
Global Const visDocuments = 11
Global Const visMaster = 12
Global Const visMasters = 13
Global Const visPage = 14
Global Const visPages = 15
Global Const visShape = 16
Global Const visShapes = 17
Global Const visStyle = 18
Global Const visStyles = 19
Global Const visWindow = 20
Global Const visWindows = 21
Global Const visSelection = 22
Global Const visConnect = 25
Global Const visConnects = 26

'Dump method parameter values
Global Const visDumpType = 0

'Select method parameter values
Global Const visDeselect = &H1
Global Const visSelect = &H2
Global Const visSubSelect = &H3
Global Const visDeselectAll = &H100

'Units constants
Global Const visNumber = &H20           'no units used
Global Const visTypeUnits = &H30        'default text type units
Global Const visPoints = &H32
Global Const visPicas = &H33
Global Const visDidots = &H35
Global Const visCiceros = &H36
Global Const visPageUnits = &H3F        'default
Global Const visDrawingUnits = &H40     'default
Global Const visInches = &H41
Global Const visFeet = &H42
Global Const visMiles = &H44
Global Const visCentimeters = &H45
Global Const visMillimeters = &H46
Global Const visMeters = &H47
Global Const visKilometers = &H48
Global Const visYards = &H4B
Global Const visAngleUnits = &H50       'default
Global Const visDegrees = &H51          'decimal degrees
Global Const visRadians = &H53

'FromPart property values
Global Const visConnectError = -1
Global Const visNone = 0
Global Const visLeftEdge = 1
Global Const visCenterEdge = 2
Global Const visRightEdge = 3
Global Const visBottomEdge = 4
Global Const visMiddleEdge = 5
Global Const visTopEdge = 6
Global Const visBeginX = 7
Global Const visBeginY = 8
Global Const visBegin = 9
Global Const visEndX = 10
Global Const visEndY = 11
Global Const visEnd = 12
Global Const visControlPoint = 100

'ToPart property values
'Global Const visConnectError = -1             'see FromPart..
'Global Const visNone = 0               'see FromPart..
Global Const visGuideX = 1
Global Const visGuideY = 2
Global Const visConnectionPoint = 100

'Cell error property values
Global Const visErrorSuccess = 0
Global Const visErrorDivideByZero = 39
Global Const visErrorValue = 47
Global Const visErrorReference = 55
Global Const visErrorName = 61
Global Const visErrorNumber = 68
Global Const visErrorNotAvailable = 74

'AddGuide method guide types
Global Const visPoint = 1
Global Const visHorz = 2
Global Const visVert = 3

'Type property values - shapes
Global Const visTypeStyle = 1
Global Const vistypeGroup = 2
Global Const visTypeShape = 3
Global Const visTypeForeignObject = 4
Global Const visTypeGuide = 5

'Type property values - windows
Global Const visDrawing = 1
Global Const visStencil = 2
Global Const visSheet = 3
Global Const visIcon = 4

'AlignName property values
Global Const visLeft = 1
Global Const visCenter = 2
Global Const visRight = 3

'IconSize property values
Global Const visNormal = 1
Global Const visTall = 2
Global Const visWide = 3
Global Const visDouble = 4

'IconUpdate property values
Global Const visAutomatic = &HFF
Global Const visManual = 0

'Text case
Global Const visCaseNormal = 0
Global Const visCaseAllCaps = 1
Global Const visCaseInitialCaps = 2

'Text position relative to shape
Global Const visPosNormal = 0
Global Const visPosSuper = 1
Global Const visPosSub = 2

'Text styles
Global Const visBold = 1
Global Const visItalic = 2
Global Const visUnderLine = 4
Global Const visSmallCaps = 8

'The possible values for the HAlign cell
Global Const visHorzLeft = 0
Global Const visHorzCenter = 1
Global Const visHorzRight = 2
Global Const visHorzJustify = 3
Global Const visHorzForce = 4

'The possible values for the tab stop Align cell
Global Const visTabStopLeft = 0
Global Const visTabStopCenter = 1
Global Const visTabStopRight = 2
Global Const visTabStopDecimal = 3
Global Const visTabStopComma = 4

'The possible values for the VAlign cell
Global Const visVertTop = 0
Global Const visVertMiddle = 1
Global Const visVertBottom = 2

'The possible values for the TextBkgnd cell
Global Const visTransparent = 0
	    'Opaque - see Visio's 24 color pallette list.

'Visio's 24 color pallette
Global Const visBlack = 0
Global Const visWhite = 1
Global Const visRed = 2
Global Const visGreen = 3
Global Const visBlue = 4
Global Const visYellow = 5
Global Const visMagenta = 6
Global Const visCyan = 7
Global Const visDarkRed = 8
Global Const visDarkGreen = 9
Global Const visDarkBlue = 10
Global Const visDarkYellow = 11
Global Const visPurple = 12
Global Const visDarkCyan = 13
Global Const visGray = 14
Global Const visGray10 = 15
Global Const visGray20 = 16
Global Const visGray30 = 17
Global Const visGray40 = 18
Global Const visDarkGray = 19
Global Const visGray50 = visDarkGray
Global Const visGray60 = 20
Global Const visGray70 = 21
Global Const visGray80 = 22
Global Const visGray90 = 23

'Patterns
'Global Const visNone = 0
Global Const visSolid = 1
Global Const visWideUpDiagonal = 2
Global Const visWideCross = 3
Global Const visWideDiagonalCross = 4
Global Const visWideDownDiagonal = 5
Global Const visWideHorz = 6
Global Const visWideVert = 7
Global Const visBackDotsMini = 8
Global Const visHalfAndHalf = 9
Global Const visForeDotsMini = 10
Global Const visForeDotsNarrow = 11
Global Const visForeDotsWide = 12
Global Const visThickHorz = 13
Global Const visThickVertial = 14
Global Const visThickDownDiagonal = 15
Global Const visThickUpDiagonal = 16
Global Const visThickDialogCross = 17
Global Const visBackDotsWide = 18
Global Const visThinHorz = 19
Global Const visThinVert = 20
Global Const visThinDownDiagonal = 21
Global Const visThinUpDiagonal = 22
Global Const visThinCross = 23
Global Const visThinDiagonalCross = 24

'-- Values for the cells that control the page's size and scale

'The possible values for the drawing size type
Global Const visPrintSetup = 0
Global Const visTight = 1
Global Const visStandard = 2
Global Const visCustom = 3
Global Const visLogical = 4

'The possible values the drawing scale type
Global Const visNoScale = 0
Global Const visArchitectural = 1
Global Const visEngineering = 2
Global Const visScaleCustom = 3

'The possible values for the page's grid density
Global Const visGridFine = 8
Global Const visGridNormal = 4
Global Const visGridCoarse = 2

'The possible values for the page's subdivision on the ruler
Global Const visRulerFine = 32
Global Const visRulerNormal = 16
Global Const visRulerCoarse = 8

'Section IDs
Global Const visSectionFirst = 0            'first logical section
Global Const visSectionLastComponent = &HFA
Global Const visSectionLast = &HFC          'last logical section
Global Const visSectionText = &HFD
Global Const visSectionForeign = &HFE
Global Const visSectionNone = &HFF          'unspecified logical section
Global Const visSectionObject = 1
Global Const visSectionMember = 2
Global Const visSectionCharacter = 3
Global Const visSectionParagraph = 4
Global Const visSectionTab = 5
Global Const visSectionScratch = 6
Global Const visSectionExport = 7
Global Const visSectionTextField = 8
Global Const visSectionControls = 9
Global Const visSectionFirstComponent = 10

'Row IDs
Global Const visRowFirst = 0                'first logical row in any section
Global Const visRowLast = -2                'last logical row in any section
Global Const visRowNone = &HFF              'unspecified row
Global Const visRowXFormOut = 1
Global Const visRowLine = 2
Global Const visRowFill = 3
Global Const visRowXForm1D = 4
Global Const visRowEvent = 5
Global Const visRowGuide = 7
Global Const visRowStyle = 8
Global Const visRowForeign = 9
Global Const visRowPage = 10
Global Const visRowText = 11
Global Const visRowTextXForm = 12
Global Const visRowXFormIn = visRowXFormOut
Global Const visRowAlign = 14
Global Const visRowLock = 15
Global Const visRowData123 = 16
Global Const visRowMisc = 17
Global Const visRowMember = 0
Global Const visRowField = 0
Global Const visRowCharacter = 0
Global Const visRowParagraph = 0
Global Const visRowTab = 0
Global Const visRowScratch = 0
Global Const visRowExport = 0
Global Const visRowControl = 0
Global Const visRowComponent = 0
Global Const visRowVertex = 1
Global Const visRowFormat = visRowControl

'Tags for rows
Global Const visTagBase = 130
Global Const visTagTab0 = 136
Global Const visTagComponent = 137
Global Const visTagMoveTo = 138
Global Const visTagLineTo = 139
Global Const visTagArcTo = 140
Global Const visTagEllipticalArcTo = 144
Global Const visTagTab2 = 150
Global Const visTagTab10 = 151
Global Const visTagInvalid = &HFF

'-- Cell IDs

'Cell IDs for vertex rows
Global Const visX = 0
Global Const visY = 1
Global Const visBow = 2
Global Const visEccentricityAngle = 4
Global Const visAspectRatio = 5
Global Const visControlX = 2
Global Const visControlY = 3

'The IDs for the cells in the Character section
Global Const visCharacterFont = 0
Global Const visCharacterColor = 1
Global Const visCharacterStyle = 2
Global Const visCharacterCase = 3
Global Const visCharacterPos = 4
Global Const visCharacterSize = 7

'The IDs for the cells in the Paragraph section
Global Const visIndentFirst = 0
Global Const visIndentLeft = 1
Global Const visIndentRight = 2
Global Const visSpaceLine = 3
Global Const visSpaceBefore = 4
Global Const visSpaceAfter = 5
Global Const visHorzAlign = 6




